#include <stdio.h>
#include <string.h>
#include "../sockev.h"
#include "../sockev_abgproc.h"
#include "../filt_split.h"

sockev_filters_t flt_linesplit[] = {
	{sockev_filter_split, "\r\n"},
	{NULL, NULL}
};

/* abgproc sockets */
void ev_bg_open(sockev_t id)
{
	printf("BG [%d] open\n", id);
	sockev_puts(id, "Hello world!\n");
}

void ev_bg_read(sockev_t id, char *buff, int len)
{
	printf("BG [%d] read: '%s'/%d\n", id, buff, len);
}

void ev_bg_close(sockev_t id)
{
	printf("BG [%d] close\n", id);
}

sockev_hooks_t ev_bg = {ev_bg_open, ev_bg_close, NULL, NULL, NULL, ev_bg_read, NULL};

void ev_ctrl_open(sockev_t id)
{
	printf("ctrl [%d] open\n", id);
}

void ev_ctrl_read(sockev_t id, char *buff, int len)
{
	printf("ctrl [%d] read: '%s'/%d\n", id, buff, len);
}

void ev_ctrl_close(sockev_t id)
{
	printf("ctrl [%d] close\n", id);
}

sockev_hooks_t ev_ctrl = {ev_ctrl_open, ev_ctrl_close, NULL, NULL, NULL, ev_ctrl_read, NULL};

void ev_err_open(sockev_t id)
{
	printf("err [%d] open\n", id);
}

void ev_err_read(sockev_t id, char *buff, int len)
{
	printf("err [%d] read: '%s'/%d\n", id, buff, len);
}

void ev_err_close(sockev_t id)
{
	printf("err [%d] close\n", id);
}

sockev_hooks_t ev_err = {ev_err_open, ev_err_close, NULL, NULL, NULL, ev_err_read, NULL};

int main()
{
	int n;
	char *cmd[] = {"sed", "-u", "s/o/0/g", NULL};
	sockev_t bg, ctrl, err;

	sockev_init();
	bg   = sockev_new(&ev_bg, 0, NULL);
	ctrl = sockev_new(&ev_ctrl, 0, NULL);
	err  = sockev_new(&ev_err, 0, NULL);
	if (sockev_abgproc(&bg, cmd, &ctrl, &err) == SOCKEV_INVALID) {
		fprintf(stderr, "test_net: can't start background proc\n");
		return 1;
	}

	printf("main loop begin\n");
	for(n = 0; n < 8; n++) {
		printf("*tick*\n");
		sockev_poll(1000);
	}
	printf("main loop end\n");
	sockev_uninit();
	return 0;
}
